#include "stdafx.h"
#include "MySplitterWindow.h"
#include "MyData.h"
#include "MyHorizontalSplitter.h"
#include "MyVerticalSplitter.h"
#include "resource.h"

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
CMySplitterWindow::CMySplitterWindow(LPCWSTR pwzClassName, UINT nCursorID) : CMyWindow(pwzClassName)
{
	m_nSplitType			= MY_SPLITTER_WINDOW_SPLIT_TYPE_TOP_LEFT;
	m_nCursor				= nCursorID;
	m_nLastPosition		= -1;
	m_bSize					= FALSE;
	m_nCurrentPosition	= 160;
	m_nSavedPosition		= 160;
	m_nRealPosition		= 160;
	m_pLeftView				= NULL;
	m_pRightView			= NULL;
	m_hResourceInstance	= CMyData::GetInstanceDLL();		
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
CMySplitterWindow::~CMySplitterWindow()
{	
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMySplitterWindow::CreateMyEx(LPCWSTR pwzTitle, DWORD dwStyle, DWORD dwStyleEx, CMyWindow* pParentWindow, UINT nMenu, UINT nBigIcon, UINT nSmallIcon, RECT* pPosition)
{
	if (dwStyle & MY_SPLITTER_WINDOW_SPLIT_TYPE_PERCENTAGE) m_nSplitType = MY_SPLITTER_WINDOW_SPLIT_TYPE_PERCENTAGE;
	if (dwStyle & MY_SPLITTER_WINDOW_SPLIT_TYPE_BOTTOM_RIGHT) m_nSplitType = MY_SPLITTER_WINDOW_SPLIT_TYPE_BOTTOM_RIGHT;
	if (dwStyle & MY_SPLITTER_WINDOW_SPLIT_TYPE_TOP_LEFT) m_nSplitType = MY_SPLITTER_WINDOW_SPLIT_TYPE_TOP_LEFT;

	return(CMyWindow::CreateMyEx(pwzTitle, WS_CHILD | WS_VISIBLE, dwStyleEx, pParentWindow, nMenu, nBigIcon, nSmallIcon, pPosition));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
int CMySplitterWindow::GetSplitterPos()
{
   return(m_nCurrentPosition);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
void CMySplitterWindow::SetSplitterPos(UINT nSplitterPos)
{
	if (nSplitterPos == 0) return;
	m_nCurrentPosition = nSplitterPos;
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMySplitterWindow::GetLeftRect(RECT* pRect)
{
	return(FALSE);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMySplitterWindow::GetRightRect(RECT* pRect)
{
	return(FALSE);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
void CMySplitterWindow::ResizeView(int nPosition, BOOL bEndDrag)
{
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMySplitterWindow::Resize(RECT* pClientRect)
{
	BOOL bRet = CMyWindow::Resize(pClientRect);

	ResizeChildView();

	return(bRet);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
void CMySplitterWindow::ResizeChildView()
{
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
void CMySplitterWindow::SetView(CMyWindow* pLeftView, CMyWindow* pRightView)
{
	m_pLeftView		= pLeftView;
	m_pRightView	= pRightView;
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMySplitterWindow::OnCommand(WPARAM wParam, LPARAM lParam)
{
	// preposilani zprav nadrizenemu oknu, ktere jiste nepatri tomuto oknu
	return(::SendMessage(GetParent(m_hWnd), WM_COMMAND, wParam, lParam));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMySplitterWindow::OnEraseBkgnd(HDC hDC)
{
	return(TRUE);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMySplitterWindow::OnLButtonDown(DWORD dwKeyIndicator, int nPositionX, int nPositionY)
{
	m_bSize = TRUE;
	SetCapture(m_hWnd);

	return(CMyWindow::OnLButtonDown(dwKeyIndicator, nPositionX, nPositionY));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMySplitterWindow::OnLButtonUp(DWORD dwKeyIndicator, int nPositionX, int nPositionY)
{
	if (m_bSize) {
		ResizeView(-1, TRUE);
		m_bSize = FALSE;
		ReleaseCapture();
		ResizeChildView();
		InvalidateWindow(TRUE);
	}

	return(CMyWindow::OnLButtonUp(dwKeyIndicator, nPositionX, nPositionY));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BYTE CMySplitterWindow::GetSplitType()
{
	return(m_nSplitType);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
void CMySplitterWindow::SetSplitType(BYTE nSplitType)
{
	switch(nSplitType) {
		case(MY_SPLITTER_WINDOW_SPLIT_TYPE_TOP_LEFT):
		case(MY_SPLITTER_WINDOW_SPLIT_TYPE_BOTTOM_RIGHT):
		case(MY_SPLITTER_WINDOW_SPLIT_TYPE_PERCENTAGE):
			m_nSplitType = nSplitType;
			break;
		default:
			m_nSplitType = MY_SPLITTER_WINDOW_SPLIT_TYPE_TOP_LEFT;
			break;
	};
}