#ifndef MyVerticalSplitterH
#define MyVerticalSplitterH

#include <windows.h>
#include "MySplitterWindow.h"

/** Tda CMyVerticalSplitter je tdou svislho rozdlovae okna. Tda zajiuje
   svoj funknost tj. zobrazen sprvnho kursoru, vykreslen, pohyb soplitteru a limity.
   Dle vol funkci pro zmnu velikosti pro nastaven horn (lev) a doln (prav) okno. */
class __declspec(dllexport) CMyVerticalSplitter : public CMySplitterWindow {
//Konstruktory a destruktor
public:
	/** Implicitn konstruktor.<BR>
		@param bAutoDelete ... flag urujc m-li se provst v destruktoru i smazn
								pamti alokovan pro prav a lev okno*/
	CMyVerticalSplitter();
	/** Destruktor*/
	virtual ~CMyVerticalSplitter();

protected:

private:



//Funkce a metody
public:
	/** Velikost levho pohledu.<BR>
		Vypln do zadan promnn obdlnk levho (hornho) pohledu.<BR>
		@param pRect ... pointer na promnnou typu RECT, do kter (pokud nen NULL) se
			vypln velikost levho (hornho) pohledu */
	virtual BOOL						GetLeftRect(RECT* pRect);
	/** Velikost pravho pohledu.<BR>
		Vypln do zadan promnn obdlnk pravho (dolnho) pohledu.<BR>
		@param pRect ... pointer na promnnou typu RECT, do kter (pokud nen NULL) se
			vypln velikost pravho (dolnho) pohledu */
	virtual BOOL						GetRightRect(RECT* pRect);	

protected:
	/** Vytvoen okna.<BR>
		Reakce na WM_CREATE, vytvoen okna.<BR>
		@param psCreateStruct ... struktura obsahujc informace o vytvoen okna */
	virtual BOOL						OnCreate(LPCREATESTRUCT psCreateStruct);
	/** Zruen okna.<BR>
		Reakce na WM_DESTROY, zruen okna.<BR>*/
	virtual BOOL						OnDestroy();
	/***/
   //virtual BOOL						OnLButtonDblClk(DWORD dwKeyIndicator, int nPositionX, int nPositionY);
	/***/
	virtual BOOL						OnMouseMove(DWORD dwKeyIndicator, int nPositionX, int nPositionY);
	/** Vykreslen okna.<BR>
		Reakce na WM_PAINT, vykresl okno.<BR>
		@param hDC ... handle DC, kreslcho zazen */
	virtual BOOL						OnPaint(HDC hDC);	

private:
	/** Zmna velikosti okna */
	virtual void						ResizeView(int nPosition, BOOL bEndDrag);
	/** Zmna velikosti podoken */
	virtual void						ResizeChildView();





//Atributy a datove cleny
public:

protected:

private:
	/** Potadlo referenc */
	static LONG							m_lCount;
	/** Pero pro vykreslen spliteru v berv jako normln okno */
	static HPEN							m_hPen;	

	

};

#endif


//Vygenerovno prostrednictvm ClassGen 1.10.001