#include "stdafx.h"
#include "ListViewPanel.h"
#include "resource.h"


//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
CListViewPanel::CListViewPanel() : CMyPanel()
{		
	m_hImageList	= NULL;
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
CListViewPanel::~CListViewPanel()
{		
	if (m_hImageList != NULL) {
		ImageList_Destroy(m_hImageList);
		m_hImageList = NULL;
	}
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CListViewPanel::OnCreate(LPCREATESTRUCT psCreateStruct)
{
	RECT	rtRect;	

	GetClientRect(&rtRect);

	m_hListView.CreateMyEx(L"", WS_CHILD | WS_VISIBLE | LVS_REPORT, WS_EX_CLIENTEDGE, this, ID_LIST_VIEW, 0, 0, &rtRect);

	InitImageList();	
	InitListView();

	return(TRUE);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CListViewPanel::OnEraseBkgnd(HDC hDC)
{
	return(TRUE);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CListViewPanel::OnNotify(WPARAM wParam, LPARAM lParam)
{
	/*
	LPNMHDR			pNMHDR		= (LPNMHDR)lParam;
	LPNMTREEVIEW	pTreeView	= (LPNMTREEVIEW)lParam;

	switch(pNMHDR->code) {
		case(TVN_SELCHANGED):			
			OnSelChanged(pTreeView->itemNew.hItem);
			break;
	};
	*/

	return(CMyWindow::OnNotify(wParam, lParam));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
void CListViewPanel::InsertBitmap(UINT nID)
{
	HBITMAP	hBitmap;

	hBitmap	= LoadBitmap(GetSafeInstance(), MAKEINTRESOURCE(nID));

	if (hBitmap != NULL) {
		ImageList_AddMasked(m_hImageList, hBitmap, RGB(0, 0, 0));

		DeleteObject(hBitmap);
	}
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
void CListViewPanel::InitImageList()
{
	m_hImageList = ImageList_Create(16, 16, ILC_COLOR32 | ILC_MASK, 5, 0);

	InsertBitmap(IDB_FOLDER_C);
	InsertBitmap(IDB_FILE);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
void CListViewPanel::InitListView()
{	
	// ukazka toho, jak se da vyuzit primy pristup k API funkcnim
	ListView_SetImageList(m_hListView.GetSafeHandle(), m_hImageList, LVSIL_SMALL);

	//m_hListView.SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES, LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);

	m_hListView.InsertColumn(0, L"Nzev", 500);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
void CListViewPanel::ChangeFolder(LPCWSTR pwzFolder)
{
	HANDLE				hFind;
	wchar_t				wzPath[MAX_PATH];
	WIN32_FIND_DATA	sFindData;
	BOOL					bRet		= TRUE;
	int					nCount	= 0;

	m_hListView.DeleteAllItems();

	wcscpy_s(wzPath, MAX_PATH, pwzFolder);
	wcscat_s(wzPath, MAX_PATH, L"*.*");
	hFind = FindFirstFile(wzPath, &sFindData);

	if (hFind != INVALID_HANDLE_VALUE) {
		while(bRet) {
			if ((sFindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == FILE_ATTRIBUTE_DIRECTORY) {
				if  ((wcscmp(sFindData.cFileName, L".") != 0) && (wcscmp(sFindData.cFileName, L"..") != 0))
					m_hListView.InsertItem(nCount++, sFindData.cFileName, 0);	
			}
			else m_hListView.InsertItem(nCount++, sFindData.cFileName, 1);

			bRet = FindNextFile(hFind, &sFindData);
		}

		FindClose(hFind);
	}	
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CListViewPanel::Resize(RECT* pClientRect)
{
	BOOL	bRet = CMyPanel::Resize(pClientRect);
	RECT	rtRect;

	GetClientRect(&rtRect);

	m_hListView.Resize(&rtRect);

	return(bRet);
}

